/*This routine converts decibels to gain factor or verce visa
   by the formula 20*log(gain).
   Credits  go to the TIGCC people- as for the inputstring conversion 
   for example. 
Dec.29.2002 Johannes Daldosch http://www.daldosch.at;mailto://office@daldosch.at*/
#define USE_TI89              // Compile for TI-89
#define USE_TI92PLUS          // Compile for TI-92 Plus
#define USE_V200              // Compile for V200
#define SAVE_SCREEN           // Save/Restore LCD Contents
#include <tigcclib.h>         // Include All Header Files
/**************Glob_Var*************************/
float Input;  // converted EnterString 
/****************SubRoutines********************************/
void InputStr(char *buffer, unsigned short maxlen);
float dBVu(float db, float W);
float VudB(float db, float W);
/****************VOIDInputstring****************************/
 
 void InputStr(char *buffer, unsigned short maxlen)
{
  SCR_STATE ss1;
  signed short key;
  unsigned short i = 0;
  buffer[0] = 0;
  
  SaveScrState (&ss1); // like clrscr() only a little different;
  do{	 
       MoveTo (ss1.CurX, ss1.CurY);       
       SaveScrState (&ss1);
        if ( i==3 ) {printf ("%s  ", buffer);}  
         else                                                                     
              printf ("%s_  ", buffer);      
         key = ngetchx ();
       if (key >= 46 && key <= 173 && i < maxlen)//46(.),173(-),149(e)  
        buffer[i++] = key;
         else if (key == KEY_BACKSPACE )  
       i--;   
       buffer[i] = 0;  
    } while (key != KEY_ENTER && key !=KEY_ESC);
     if (key==KEY_ESC) printf("\n\n\n       game over");
     else
      Input= atof(buffer); //creates float
                  
}     
/*****************dB>Vu********************************/
float dBVu (float db, float fac)
{
	fac=pow(10,(db/20));
	return fac;
}
/******************Vu>dB*******************************/
float VudB(float db, float fac)
{
	 db=20*log10(fac);
	 return db;
}
/******************Main********************************/

void _main(void)
{

WINDOW w1;
  short unsigned key;
  double fac,db;
  char str[6];
  const char *str0="\n\n  > fac 1 = 0 dB <\n\n";
  const char *str1="\n  <<Gain<-dB|fac ->dB >>";
  const char *str2="\n\n    Enter Gain: ";
  const char *str3="\n\n      Enter dB:";
  const char *str4="\n\n    < Game over >";
  const char *str5="\n\n    < No neg. gain! >";
  	  
  do
 { 
 WinOpen(&w1,&(WIN_RECT){20,20,80,50},WF_SAVE_SCR|WF_TTY);
                         WinBackground(&w1,A_REVERSE);
                         WinAttr(&w1,A_NORMAL);
                         WinFont(&w1,F_8x10);	                       
  clrscr ();
  printf(str0);// <faqc 1 = 0 dB>
   
    WinOpen(&w1,&(WIN_RECT){20,20,80,50},WF_SAVE_SCR|WF_TTY);
                         WinBackground(&w1,A_REVERSE);
                         WinAttr(&w1,A_NORMAL);
                         WinFont(&w1,F_6x8);	
   printf(str1);// <<Gain<-dB|fac->dB>>
     key=ngetchx ();
    } while (key!=338&&key!=344&&key!=264); 
         if (key==338)
             { clrscr ();printf(str3); 
                                       InputStr(str,3); //dB->fac
                        db=Input; dBVu(db,fac); fac=dBVu(db,fac);//result
                    if(db<=10&&db>=0) printf("\n\n  %2.1fdBm = factor%2.3f",db,fac);
               else if(db<=40&&db>10) printf("\n\n  %2.1fdB = factor%3.1f ",db,fac);  
               else if(db<=50&&db>40) printf("\n\n  %2.1fdB = factor%3.1f ",db,fac); 
               else if(db<=70&&db>50) printf("\n\n %2.1fdB = factor%1.2e ",db,fac);
               else if(db<=100&&db>70)printf("\n\n %2.1fdB = factor%1.2e ",db,fac);
                else if(db>=-10&&db<0)printf("\n\n %2.1fdB = factor%0.3f ",db,fac);
              else if(db>=-30&&db<-10)printf("\n\n %2.1fdB = factor%0.4f ",db,fac);
              else if(db>=-50&&db<-30)printf("\n\n   %2.1fdB = factor%0.2e ",db,fac);
              else if(db>=-70&&db<-50)printf("\n\n   %2.1fdB = factor%0.2e ",db,fac);
             else if(db>=-100&&db<-70)printf("\n\n   %2.1fdB = factor%0.2e ",db,fac);}
             
                             /*******************************/                        
    else if (key==344) { clrscr ();printf(str2);InputStr(str,7); //fac->dB
                      fac=Input; VudB(db,fac); db=VudB(db,fac);//result
                    if (Input<0) printf (str5); //There is no(- mW)
else if (Input>1e7  &&  Input<=1e10)printf("\n\n  factor %1.1e = %3.1fdB",fac,db);
else if (Input>1e5  &&  Input<=1e7)printf ("\n\n  factor %1.1e = %2.1fdB",fac,db);
else if (Input>10   &&  Input<=1e5)printf ("\n\n  factor %4.1f = %2.1fdB",fac,db);
else if (Input>0.1  &&  Input<=10) printf ("\n\n  factor %3.2f = %2.2fdB",fac,db);                                                           
else if (Input>0.001&&  Input<=0.1)printf ("\n\n  factor %0.3f = %2.1fdB",fac,db);                           
else if (Input>1e-5 &&Input<=0.001)printf  ("\n\n factor %1.2e = %1.2fdB",fac,db);                           
else if (Input>=1e-7&& Input<=1e-5)printf  ("\n\n factor %1.2e = %2.2fdB",fac,db);                           
else if (Input>=1e-10&& Input<=1e-7)printf ("\n\n factor %1.2e = %2.2fdB",fac,db);}                           
                               
     else if (key==264) { clrscr ();printf(str4);}
                            
   ngetchx(); 
}   



